<?php

/*
Type in the domain names that are allowed to use this script.
This is very important because if this is not defined then anyone can use this script for their use.

The default values below is just the brosner.com server. Be sure to add yours in place of mine. You can specify the name. No WWW in the name.
*/
$domains = array(
0 => "brosner.com");

/*
You can change the From line in the e-mail to anything you'd like.
*/
$mail_from = "Web Form";

/* 
If you want to change how the seperator between the field and value in the e-mail do so below.
Default - field: value
The : is your seperator
*/
$seperator = ": ";

/*
You may edit the regular expression used for cehcking emails.
Leave as is if you don't know how to make regular expressions or what you see is complete gibberish.
*/
$email_reg_ex = "^[^@ ]+@[^@ ]+\.[^@\.]+$";

/*** DO NOT EDIT BELOW THIS LINE ***/

// declare some vars global
global $recipients,$subject,$required,$redirect;

// fetch the defined data in the form
$recipients = $_POST["recipients"];
$subject = $_POST["subject"];
$required = $_POST["required"];
$redirect = $_POST["redirect"];

// remove parts of the _POST data
unset($_POST["recipients"],$_POST["subject"],$_POST["required"],$_POST["redirect"]);

// perform the proper seperation of the hidden fields
$emails = explode(",",$recipients);

// create a function that outputs our errors
function print_error($error,$kill = false) {
    
    // display the error
    print "<font face=\"verdana\" size=\"2\" color=\"#ff0000\"><b>Error:</b> ".$error."</font><br />\n";
    
    // if kill equals true terminate the script
    if($kill == true) exit;
    
    // end function
    return 0;
}

// create a function that checks the specified url against the allowed ones
function check_referer() {
    // grab outside the function variables
    global $domains;
    
    // grab the url of the form
    $replace = str_replace("http://","",getenv("HTTP_REFERER"));
    $referer = strtok($replace,"/");

    // set up a domain counter var then loop the test them all
    $domain_count = 0;
    foreach($domains as $index => $domain) {
        $this_domain = "www.".$domain;
        if($this_domain == $referer) $domain_count++;
    }
    // test if any were good
    if($domain_count >= 1) return true;
    else return false;
}

function check_hidden() {
    // make certain vars available within the function
    global $recipients,$subject,$redirect,$emails;
    global $email_reg_ex;
    
    if($recipients == "") print_error("Please enter an e-mail address in the recipients hidden field.",true);
    else {
        // loop through the e-mails and test to see if they are in vaild form
        foreach($emails as $index => $email) {
            if(!eregi($email_reg_ex,$email,$trash)) {
                print_error("The e-mail address ".$email." is not a valid e-mail.<br />\n");
                if((sizeof($emails) - 1) == $index) exit;
            }
        }
    }
    if($subject == "") $subject = "Web Form Submission";
    if($redirect == "") $redirect = "default";

    // end func
    return 0;
}

/*** VALIDATION FUNCTIONS ***/
function vali_blank($field,$val) {
    if($val == "") {
        print_error("The ".$field." field was left empty.");
        return false;
    }
    else return true;
}

function vali_email($field,$val) {
    global $email_reg_ex;

    if(vali_blank($field,$val)) {
        if(!eregi($email_reg_ex,$val,$trash)) {
            print_error("The email address supplied in the ".$field." field is in incorrect format.");
            return false;
        }
        else return true;
    }
}

function vali_letters($field,$val) {
    if(vali_blank($field,$val)) {
        if(!eregi("^[a-z]+$",$val)) {
            print_error("Only letters are accepted in the ".$field." field.");
            return false;
        }
        else return true;
    }
}

function vali_numbers($field,$val) {
    if(vali_blank($field,$val)) {
        if(!eregi("^[0-9]+$",$val)) {
            print_error("Only numbers are accepted in the ".$field." field");
            return false;
        }
        else return true;
    }
}

function vali_age($field,$val) {
    // test blank first
    if(vali_blank($field,$val)) {
        // split the birthdate up in month, day and year
        list($month,$day,$year) = explode("/",$val);

        // if they put a two digit year change it to four with the 19 prefix
        if(strlen($year) == 2) $year = "19".$year;

        // test to see if the date given is even a date on the calendar
        if(!checkdate($month,$day,$year)) {
            print_error("The given date in the ".$field." field is not a valid date.");
            return false;
        }

        // grab an array of date info
        $bd_date = getdate(mktime(0,0,0,$month,$day,$year));
        $now_date = getdate(time());

        //adjust for day of the month and get final age. 
        if($now_date["yday"] >= $bd_date["yday"]) $age = $now_date["year"] - $year;
        else $age = ($now_date["year"] - $year) - 1;
        
        //age range check 
        if($age < 13) {
            print_error("According to the <a href=\"http://www.ftc.gov/bcp/conline/pubs/buspubs/coppa.htm\">COPPA</a> you must be 13 years of age or older to submit data on this website.");
            return false;
        }
        else return true;
    }
}

function break_req($req) {
    // break each validation type
    $each_set = explode("|",$req);

    // set up an array
    $req_all = array();

    // loop through and kill the () and grab the types etc..
    while(list($i,$req_whole) = each($each_set)) {
        // place a bomb on the comma to explode it to pieces =)
        $this_val = explode(".",$req_whole);

        // test if it seperated anything, if not then set default vali type to the field
        if($this_val[0] == $req_whole) {
            $field = eregi_replace("\[|\]","",$this_val[0]);
            $vali_type = "blank";
        }
        else {
            $field = eregi_replace("\[","",$this_val[0]);
            $vali_type = eregi_replace("\]","",$this_val[1]);
        }
        
        // throw stuff into an array
        $req_all[$field] = $vali_type;
    }

    return $req_all;
}

function check_required() {
    global $required;
    // grab the required fields from the form
    $req = break_req($required);

    // loop through the post vars
    $field_count = 0;
    while(list($var,$val) = each($_POST)) {
        if(isset($req[$var])) {
            eval("\$this_vali = vali_".$req[$var]."(\"".$var."\",\"".$val."\");\n");
            if($this_vali == false) $field_count++;
        }
    }
    if($field_count >= 1) {
        print "<br /><font face=\"verdana\" size=\"2\">Please <a href=\"#\" onclick=\"history.go(-1);\">go back</a> and correct these errors. Thank you.";
        exit;
    }

    return 0;
}

function build_mail() {
    global $seperator;
    
    // build body head
    $body = "FORM INFORMATION:\n";
    $body .= "-------------------------\n";
    $body .= "Sent: ".date("n/d/Y - h:i:s A T")."\n";
    $body .= "Browser: ".$_SERVER["HTTP_USER_AGENT"]."\n";
    $body .= "IP: ".$_SERVER["REMOTE_ADDR"]."\n\n";
    
    // build the form values in to e-mail
    $body .= "FORM VALUES:\n";
    $body .= "-------------------------\n";

    // reset the pointer in the post global
    reset($_POST);

    // loop thorugh and output to email
    while(list($var,$val) = each($_POST)) {
        if($var != "submit") {
            $body .= $var.$seperator.$val."\n";
        }
    }
    return $body;
}


function send_mail($emails,$subject,$body,$headers) {
    // send the mail to all the e-mails specified
    while(list($index,$email) = each($emails)) {
        $mail = mail($email,$subject,$body,$headers);
        if(!$mail) {
            print_error("The mail did not reach the mail server.",true);
        }
    }

    return 0;
}


if(check_referer() == false) print_error("Access Denied.",true);

// check the hidden fields
check_hidden();

// check the required filed and returns error when necessary
check_required();

// build mail body
$body = build_mail();

// build headers
$headers = "From: ".$mail_from."\r\n";

send_mail($emails,$subject,$body,$headers);

if($redirect == "default") {
    print "<font face=\"verdana\" size=\"2\"><b>Form was successfully sent.</b></font>";
}
else {
    @header("Location: ".$redirect);
}

?>